/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, Option, OptionOrNullable, ReadonlyAccount, ReadonlySignerAccount, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { MPL_CORE_PROGRAM_PROGRAM_ADDRESS } from '../programs';
import { Authority, AuthorityArgs, Plugin, PluginArgs } from '../types';
export type AddCollectionPluginV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountCollection extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountLogWrapper extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountCollection extends string ? WritableAccount<TAccountCollection> : TAccountCollection,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    ...TRemainingAccounts
]>;
export type AddCollectionPluginV1InstructionData = {
    discriminator: number;
    plugin: Plugin;
    initAuthority: Option<Authority>;
};
export type AddCollectionPluginV1InstructionDataArgs = {
    plugin: PluginArgs;
    initAuthority: OptionOrNullable<AuthorityArgs>;
};
export declare function getAddCollectionPluginV1InstructionDataEncoder(): Encoder<AddCollectionPluginV1InstructionDataArgs>;
export declare function getAddCollectionPluginV1InstructionDataDecoder(): Decoder<AddCollectionPluginV1InstructionData>;
export declare function getAddCollectionPluginV1InstructionDataCodec(): Codec<AddCollectionPluginV1InstructionDataArgs, AddCollectionPluginV1InstructionData>;
export type AddCollectionPluginV1Input<TAccountCollection extends string = string, TAccountPayer extends string = string, TAccountAuthority extends string = string, TAccountSystemProgram extends string = string, TAccountLogWrapper extends string = string> = {
    /** The address of the asset */
    collection: Address<TAccountCollection>;
    /** The account paying for the storage fees */
    payer: TransactionSigner<TAccountPayer>;
    /** The owner or delegate of the asset */
    authority?: TransactionSigner<TAccountAuthority>;
    /** The system program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The SPL Noop Program */
    logWrapper?: Address<TAccountLogWrapper>;
    plugin: AddCollectionPluginV1InstructionDataArgs['plugin'];
    initAuthority: AddCollectionPluginV1InstructionDataArgs['initAuthority'];
};
export declare function getAddCollectionPluginV1Instruction<TAccountCollection extends string, TAccountPayer extends string, TAccountAuthority extends string, TAccountSystemProgram extends string, TAccountLogWrapper extends string>(input: AddCollectionPluginV1Input<TAccountCollection, TAccountPayer, TAccountAuthority, TAccountSystemProgram, TAccountLogWrapper>): AddCollectionPluginV1Instruction<typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountCollection, TAccountPayer, TAccountAuthority, TAccountSystemProgram, TAccountLogWrapper>;
export type ParsedAddCollectionPluginV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The address of the asset */
        collection: TAccountMetas[0];
        /** The account paying for the storage fees */
        payer: TAccountMetas[1];
        /** The owner or delegate of the asset */
        authority?: TAccountMetas[2] | undefined;
        /** The system program */
        systemProgram: TAccountMetas[3];
        /** The SPL Noop Program */
        logWrapper?: TAccountMetas[4] | undefined;
    };
    data: AddCollectionPluginV1InstructionData;
};
export declare function parseAddCollectionPluginV1Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedAddCollectionPluginV1Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=addCollectionPluginV1.d.ts.map