/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, ReadonlySignerAccount, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { MPL_CORE_PROGRAM_PROGRAM_ADDRESS } from '../programs';
import { PluginType, PluginTypeArgs } from '../types';
export type RevokeCollectionPluginAuthorityV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountCollection extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountLogWrapper extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountCollection extends string ? WritableAccount<TAccountCollection> : TAccountCollection,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    ...TRemainingAccounts
]>;
export type RevokeCollectionPluginAuthorityV1InstructionData = {
    discriminator: number;
    pluginType: PluginType;
};
export type RevokeCollectionPluginAuthorityV1InstructionDataArgs = {
    pluginType: PluginTypeArgs;
};
export declare function getRevokeCollectionPluginAuthorityV1InstructionDataEncoder(): Encoder<RevokeCollectionPluginAuthorityV1InstructionDataArgs>;
export declare function getRevokeCollectionPluginAuthorityV1InstructionDataDecoder(): Decoder<RevokeCollectionPluginAuthorityV1InstructionData>;
export declare function getRevokeCollectionPluginAuthorityV1InstructionDataCodec(): Codec<RevokeCollectionPluginAuthorityV1InstructionDataArgs, RevokeCollectionPluginAuthorityV1InstructionData>;
export type RevokeCollectionPluginAuthorityV1Input<TAccountCollection extends string = string, TAccountPayer extends string = string, TAccountAuthority extends string = string, TAccountSystemProgram extends string = string, TAccountLogWrapper extends string = string> = {
    /** The address of the asset */
    collection: Address<TAccountCollection>;
    /** The account paying for the storage fees */
    payer: TransactionSigner<TAccountPayer>;
    /** The owner or delegate of the asset */
    authority?: TransactionSigner<TAccountAuthority>;
    /** The system program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The SPL Noop Program */
    logWrapper?: Address<TAccountLogWrapper>;
    pluginType: RevokeCollectionPluginAuthorityV1InstructionDataArgs['pluginType'];
};
export declare function getRevokeCollectionPluginAuthorityV1Instruction<TAccountCollection extends string, TAccountPayer extends string, TAccountAuthority extends string, TAccountSystemProgram extends string, TAccountLogWrapper extends string>(input: RevokeCollectionPluginAuthorityV1Input<TAccountCollection, TAccountPayer, TAccountAuthority, TAccountSystemProgram, TAccountLogWrapper>): RevokeCollectionPluginAuthorityV1Instruction<typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountCollection, TAccountPayer, TAccountAuthority, TAccountSystemProgram, TAccountLogWrapper>;
export type ParsedRevokeCollectionPluginAuthorityV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The address of the asset */
        collection: TAccountMetas[0];
        /** The account paying for the storage fees */
        payer: TAccountMetas[1];
        /** The owner or delegate of the asset */
        authority?: TAccountMetas[2] | undefined;
        /** The system program */
        systemProgram: TAccountMetas[3];
        /** The SPL Noop Program */
        logWrapper?: TAccountMetas[4] | undefined;
    };
    data: RevokeCollectionPluginAuthorityV1InstructionData;
};
export declare function parseRevokeCollectionPluginAuthorityV1Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedRevokeCollectionPluginAuthorityV1Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=revokeCollectionPluginAuthorityV1.d.ts.map