/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, Option, OptionOrNullable, ReadonlyAccount, ReadonlySignerAccount, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { MPL_CORE_PROGRAM_PROGRAM_ADDRESS } from '../programs';
import { CompressionProof, CompressionProofArgs } from '../types';
export type TransferV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountAsset extends string | IAccountMeta<string> = string, TAccountCollection extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountNewOwner extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = string, TAccountLogWrapper extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountAsset extends string ? WritableAccount<TAccountAsset> : TAccountAsset,
    TAccountCollection extends string ? ReadonlyAccount<TAccountCollection> : TAccountCollection,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountNewOwner extends string ? ReadonlyAccount<TAccountNewOwner> : TAccountNewOwner,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    ...TRemainingAccounts
]>;
export type TransferV1InstructionData = {
    discriminator: number;
    compressionProof: Option<CompressionProof>;
};
export type TransferV1InstructionDataArgs = {
    compressionProof: OptionOrNullable<CompressionProofArgs>;
};
export declare function getTransferV1InstructionDataEncoder(): Encoder<TransferV1InstructionDataArgs>;
export declare function getTransferV1InstructionDataDecoder(): Decoder<TransferV1InstructionData>;
export declare function getTransferV1InstructionDataCodec(): Codec<TransferV1InstructionDataArgs, TransferV1InstructionData>;
export type TransferV1Input<TAccountAsset extends string = string, TAccountCollection extends string = string, TAccountPayer extends string = string, TAccountAuthority extends string = string, TAccountNewOwner extends string = string, TAccountSystemProgram extends string = string, TAccountLogWrapper extends string = string> = {
    /** The address of the asset */
    asset: Address<TAccountAsset>;
    /** The collection to which the asset belongs */
    collection?: Address<TAccountCollection>;
    /** The account paying for the storage fees */
    payer: TransactionSigner<TAccountPayer>;
    /** The owner or delegate of the asset */
    authority?: TransactionSigner<TAccountAuthority>;
    /** The new owner to which to transfer the asset */
    newOwner: Address<TAccountNewOwner>;
    /** The system program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The SPL Noop Program */
    logWrapper?: Address<TAccountLogWrapper>;
    compressionProof: TransferV1InstructionDataArgs['compressionProof'];
};
export declare function getTransferV1Instruction<TAccountAsset extends string, TAccountCollection extends string, TAccountPayer extends string, TAccountAuthority extends string, TAccountNewOwner extends string, TAccountSystemProgram extends string, TAccountLogWrapper extends string>(input: TransferV1Input<TAccountAsset, TAccountCollection, TAccountPayer, TAccountAuthority, TAccountNewOwner, TAccountSystemProgram, TAccountLogWrapper>): TransferV1Instruction<typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountAsset, TAccountCollection, TAccountPayer, TAccountAuthority, TAccountNewOwner, TAccountSystemProgram, TAccountLogWrapper>;
export type ParsedTransferV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The address of the asset */
        asset: TAccountMetas[0];
        /** The collection to which the asset belongs */
        collection?: TAccountMetas[1] | undefined;
        /** The account paying for the storage fees */
        payer: TAccountMetas[2];
        /** The owner or delegate of the asset */
        authority?: TAccountMetas[3] | undefined;
        /** The new owner to which to transfer the asset */
        newOwner: TAccountMetas[4];
        /** The system program */
        systemProgram?: TAccountMetas[5] | undefined;
        /** The SPL Noop Program */
        logWrapper?: TAccountMetas[6] | undefined;
    };
    data: TransferV1InstructionData;
};
export declare function parseTransferV1Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedTransferV1Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=transferV1.d.ts.map