/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, ReadonlySignerAccount, ReadonlyUint8Array, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { MPL_CORE_PROGRAM_PROGRAM_ADDRESS } from '../programs';
import { ExternalPluginAdapterKey, ExternalPluginAdapterKeyArgs } from '../types';
export type WriteExternalPluginAdapterDataV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountAsset extends string | IAccountMeta<string> = string, TAccountCollection extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountLogWrapper extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountAsset extends string ? WritableAccount<TAccountAsset> : TAccountAsset,
    TAccountCollection extends string ? WritableAccount<TAccountCollection> : TAccountCollection,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    ...TRemainingAccounts
]>;
export type WriteExternalPluginAdapterDataV1InstructionData = {
    discriminator: number;
    key: ExternalPluginAdapterKey;
    data: ReadonlyUint8Array;
};
export type WriteExternalPluginAdapterDataV1InstructionDataArgs = {
    key: ExternalPluginAdapterKeyArgs;
    data: ReadonlyUint8Array;
};
export declare function getWriteExternalPluginAdapterDataV1InstructionDataEncoder(): Encoder<WriteExternalPluginAdapterDataV1InstructionDataArgs>;
export declare function getWriteExternalPluginAdapterDataV1InstructionDataDecoder(): Decoder<WriteExternalPluginAdapterDataV1InstructionData>;
export declare function getWriteExternalPluginAdapterDataV1InstructionDataCodec(): Codec<WriteExternalPluginAdapterDataV1InstructionDataArgs, WriteExternalPluginAdapterDataV1InstructionData>;
export type WriteExternalPluginAdapterDataV1Input<TAccountAsset extends string = string, TAccountCollection extends string = string, TAccountPayer extends string = string, TAccountAuthority extends string = string, TAccountSystemProgram extends string = string, TAccountLogWrapper extends string = string> = {
    /** The address of the asset */
    asset: Address<TAccountAsset>;
    /** The collection to which the asset belongs */
    collection?: Address<TAccountCollection>;
    /** The account paying for the storage fees */
    payer: TransactionSigner<TAccountPayer>;
    /** The Data Authority of the External PluginExternalPluginAdapter */
    authority?: TransactionSigner<TAccountAuthority>;
    /** The system program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The SPL Noop Program */
    logWrapper?: Address<TAccountLogWrapper>;
    key: WriteExternalPluginAdapterDataV1InstructionDataArgs['key'];
    data: WriteExternalPluginAdapterDataV1InstructionDataArgs['data'];
};
export declare function getWriteExternalPluginAdapterDataV1Instruction<TAccountAsset extends string, TAccountCollection extends string, TAccountPayer extends string, TAccountAuthority extends string, TAccountSystemProgram extends string, TAccountLogWrapper extends string>(input: WriteExternalPluginAdapterDataV1Input<TAccountAsset, TAccountCollection, TAccountPayer, TAccountAuthority, TAccountSystemProgram, TAccountLogWrapper>): WriteExternalPluginAdapterDataV1Instruction<typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountAsset, TAccountCollection, TAccountPayer, TAccountAuthority, TAccountSystemProgram, TAccountLogWrapper>;
export type ParsedWriteExternalPluginAdapterDataV1Instruction<TProgram extends string = typeof MPL_CORE_PROGRAM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The address of the asset */
        asset: TAccountMetas[0];
        /** The collection to which the asset belongs */
        collection?: TAccountMetas[1] | undefined;
        /** The account paying for the storage fees */
        payer: TAccountMetas[2];
        /** The Data Authority of the External PluginExternalPluginAdapter */
        authority?: TAccountMetas[3] | undefined;
        /** The system program */
        systemProgram: TAccountMetas[4];
        /** The SPL Noop Program */
        logWrapper?: TAccountMetas[5] | undefined;
    };
    data: WriteExternalPluginAdapterDataV1InstructionData;
};
export declare function parseWriteExternalPluginAdapterDataV1Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedWriteExternalPluginAdapterDataV1Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=writeExternalPluginAdapterDataV1.d.ts.map